Attribute VB_Name = "Module1"
Option Explicit
'options used in-shop with T thermocoupler
'Type=T
'Gain = 0.247
'Kfactor = 18.5
Public fLogNameShowing As Boolean
Public strScanLogfileName As String

Public bMainChan As Byte
Public bNumChans As Byte

Public Const CONFIG_DEV = 0
Public Const CONFIG_RATE = 1
Public Const CONFIG_AVG = 2
Public Const CONFIG_NUM_CHANS = 3
Public Const CONFIG_TYPE = 4
Public Const CONFIG_GAIN = 5
Public Const CONFIG_K_FACTOR = 6
Public Const CONFIG_MAIN_CHAN = 7
Public Const CONFIG_ARRAY_SIZE = 7
Public bConfigChanges(CONFIG_ARRAY_SIZE + 1) As Byte

Public sType As String

Public dblGain As Double
Public dblKfactor As Double


Public f40msTimerBusy As Boolean

Public Const SINGLE_CHAN_SCAN = 1
Public Const INIT_DEV_SIGNON_SUCCESS = &H10000
Public Const MAX_DEV_CNT = 32
Public Const NO_DLL_SHOWLIST = 0
Public Const MODEL_UNKNOWN = 0: Public Const MODEL_301 = 1: Public Const MODEL_302 = 2

Public fRetVal As Boolean
Public fSignedOn As Boolean
Public fDevID_Changing As Boolean
Public fRetValMisc As Boolean

Public fExitNow As Boolean
Public fReadBusy As Boolean

Public fStopTempRead As Boolean

Public bCurChan As Byte
Public bModelType As Byte
Public bLastDigin As Byte
Public bDigOutVal As Byte
Public bFuncRetVal As Byte
Public bNumDevices As Byte

Public dblCurRate As Double

Public usProgressBarVal As Integer
Public usMainDevID As Integer
Public MainFormTop As Integer
Public MainFormLeft As Integer
Public iAverage As Integer

Public hLibLL_USB As Long

Public ausLLABS_DeviceIDList(MAX_DEV_CNT) As Integer
Public adblDevRate(MAX_DEV_CNT) As Double
Public adblAvgVoltages() As Double


Public pauiDataBuff() As Long
Public usNumPointsToRead As Integer
Public fReadingTemps As Byte



'BOOLEAN SP_DisableDialog()
Declare Function SP_DisableDialog Lib "LL_USB2k.DLL" () As Byte

'BOOLEAN SP_InitAllDevices(USHORT* pDevList, BYTE* pbNumDevices_LV, DOUBLE* pdblDevRate, BOOLEAN fShowDevList)
Declare Function SP_InitAllDevices Lib "LL_USB2k.DLL" (ByRef pusaLLABS_DeviceIDList As Integer, ByRef pbNumDevices As Byte, ByRef padblDevRate As Double, ByVal fShowList As Byte) As Byte

'BOOLEAN SP_InitAllDevices_Thread(USHORT* pDevList, DOUBLE* pdblDevRate, BOOLEAN fShowDevList)
Declare Function SP_InitAllDevices_Thread Lib "LL_USB2k.DLL" (ByRef pusaLLABS_DeviceIDList As Integer, ByRef padblDevRate As Double, ByVal fShowList As Byte) As Byte

'BOOLEAN SP_GetInitThreadStat (void)
Declare Function SP_GetInitThreadStat Lib "LL_USB2k.DLL" () As Byte

'BOOLEAN SP_GetLastInitStat(USHORT* pDevList, UINT* puiFlags);
Declare Function SP_GetLastInitStat Lib "LL_USB2k.DLL" (ByRef pausDevIDList As Integer, ByRef pausDevStatList As Long) As Byte

'BOOLEAN SP_GetLastInitDevAndRates(USHORT* pDevList, double* pdblRates);
Declare Function SP_GetLastInitDevAndRates Lib "LL_USB2k.DLL" (ByRef pusaLLABS_DeviceIDList As Integer, ByRef padblDevRate As Double) As Byte

'BOOLEAN SP_GetOneConversion(USHORT usDevID, UINT* uiConvRawCount, BYTE bCurChan, BYTE* pbLastDigin);
Declare Function SP_GetOneConversion Lib "LL_USB2k.DLL" (ByVal usDeviceID As Integer, ByRef puiConvRawCount As Long, ByVal bCurChan As Byte, ByRef pbDigInput As Byte) As Byte

'BOOLEAN SP_SendChan(USHORT usDevID, BYTE bCurChan, BYTE* pbLastDigin)
Declare Function SP_SendChan Lib "LL_USB2k.DLL" (ByVal usDeviceID As Integer, ByVal bCurChan As Byte, ByRef pbDigInput As Byte) As Byte

'BOOLEAN SP_SendDAC(USHORT usDevID, DOUBLE dblVoltage, BYTE bDAC, BYTE* pbReserved);
Declare Function SP_SendDAC Lib "LL_USB2k.DLL" (ByVal usDeviceID As Integer, ByVal dblVoltage As Double, ByVal bDAC As Byte, ByRef pbReserved As Byte) As Byte

'BOOLEAN SP_SendDigOut(USHORT usDevID, BYTE bDigOutVal, BYTE* pbLastDigin)
Declare Function SP_SendDigOut Lib "LL_USB2k.DLL" (ByVal usDeviceID As Integer, ByVal bDigOutVal As Byte, ByRef pbDigInput As Byte) As Byte
        
'BOOLEAN SP_SendRate(DOUBLE* dblRate, USHORT usDevID)
Declare Function SP_SendRate Lib "LL_USB2k.DLL" (ByRef pdblRate As Double, ByVal usDeviceID As Integer) As Byte

'WINAPI Functions
Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Declare Function MessageBox Lib "user32" Alias "MessageBoxA" (ByVal hwnd As Long, ByVal lpText As String, ByVal lpCaption As String, ByVal wType As Long) As Long
Declare Function GetPrivateProfileInt Lib "kernel32" Alias "GetPrivateProfileIntA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal nDefault As Long, ByVal lpFileName As String) As Long
Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Public Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long
Public Sub LoadLibraries()
    hLibLL_USB = LoadLibrary("LL_USB2k.DLL")
    If hLibLL_USB = 0 Then GoTo NO_LL_USBLib
    bFuncRetVal = True
    GoTo EXIT1
NO_LL_USBLib:
    MsgBox ("ERROR finding LL_USB2k.DLL" & vbCrLf _
        & "Locate and place file in Windows directory, or" & vbCrLf _
        & "same directory as application and try again." & vbCrLf)
    bFuncRetVal = False
EXIT1:
    On Error GoTo 0
End Sub
Public Sub UnLoadLibraries()
    On Error GoTo EXIT1
    bFuncRetVal = FreeLibrary(hLibLL_USB)
    hLibLL_USB = 0
EXIT1:
    On Error GoTo 0
End Sub
Public Function ScrollText(Direction As String)
    If Direction = "down" Then
        frmMain.txtMsgDisplay.SelStart = Len(frmMain.txtMsgDisplay) & vbCrLf
    ElseIf Direction = "end" Then
        frmMain.txtMsgDisplay.SelStart = Len(frmMain.txtMsgDisplay)
    End If
End Function
Public Function CheckIniExist() As Boolean
    'do a fake read of the ini without any alternate parameters set to see if it exists
    Dim lRetVal_LOCAL As Long, strIniString As String: strIniString = String(32, vbNullChar)
    On Error GoTo EXIT_ERR
    lRetVal_LOCAL = GetPrivateProfileString("SPEC", "Rate", "100", strIniString, 8, "USB_35b2.ini")
    
    If lRetVal_LOCAL = 0 Then
        CheckIniExist = False: GoTo EXIT1
    End If
    CheckIniExist = True: GoTo EXIT1

EXIT_ERR:
     CheckIniExist = False
     
EXIT1:
    On Error GoTo 0

End Function
Public Sub ReadIniFileSpecs_SF()
    Dim lRetVal_LOCAL As Long
    Dim strIniString As String: strIniString = String(32, vbNullChar)

    If CheckIniExist = False Then GoTo EXIT_ERR

    On Error GoTo EXIT_ERR
    
    lRetVal_LOCAL = GetPrivateProfileString("SPEC", "DevID", "100", strIniString, 8, "USB_35b2.ini")
    usMainDevID = Val(strIniString)
    If (usMainDevID < 165) Or (dblCurRate > 499) Then usMainDevID = 425
    frmMain.txtDevID = CStr(usMainDevID)
    
    lRetVal_LOCAL = GetPrivateProfileString("SPEC", "Rate", "100", strIniString, 8, "USB_35b2.ini")
    dblCurRate = CDbl(strIniString)
    If (dblCurRate < 50) Or (dblCurRate > 1000) Then dblCurRate = 100
    frmMain.ComboRate = CStr(dblCurRate)
    
    lRetVal_LOCAL = GetPrivateProfileString("SPEC", "Gain", "100", strIniString, 8, "USB_35b2.ini")
    dblGain = CDbl(strIniString)
    If (dblGain < 0.2) Or (dblGain > 1#) Then dblGain = 0.8
    frmMain.txtGain.Text = CStr(dblGain)
    
    
    lRetVal_LOCAL = GetPrivateProfileString("SPEC", "Kfactor", "100", strIniString, 8, "USB_35b2.ini")
    dblKfactor = CDbl(strIniString)
    If (dblKfactor < 10#) Or (dblKfactor > 20#) Then dblKfactor = 11.53
    frmMain.txtKFactor.Text = CStr(dblKfactor)
    
    iAverage = GetPrivateProfileInt("SPEC", "Avg", 4, "USB_35b2.ini")
    If (iAverage < 1) Or (iAverage > 16) Then iAverage = 4
    
'Type=k  ?
'Gain = 0.8097
'Kfactor = 11.41

    lRetVal_LOCAL = GetPrivateProfileString("SPEC", "Type", "k", strIniString, 3, "USB_35b2.ini")
    sType = Mid(strIniString, 1, 1)
    sType = UCase(sType)
    frmMain.comboThermCplType.Text = sType
    
    lRetVal_LOCAL = GetPrivateProfileString("SPEC", "MainChan", "0", strIniString, 3, "USB_35b2.ini")
    bMainChan = Mid(strIniString, 1, 1)
    frmMain.ComboChan.Text = bMainChan
    
    
    lRetVal_LOCAL = GetPrivateProfileString("SPEC", "NumChans", "5", strIniString, 3, "USB_35b2.ini")
    bNumChans = CByte(strIniString)
    If (bNumChans < 2) Or (bNumChans > 14) Then bNumChans = 14
    frmMain.ComboNumChans.Text = bNumChans
'    frmMain.ComboNumCh_Click
    
    
    
    
    GoTo EXIT1

EXIT_ERR:
    MsgBox vbCrLf & "Failed to read  USB_35b2.ini" & vbCrLf & vbCrLf & "Locate file and place in  Windows  directory." & vbCrLf & vbCrLf & "Or inspect for incorrect data format" & vbCrLf & vbCrLf

EXIT1:
    On Error GoTo 0
End Sub




